'use strict';

Object.defineProperty(exports, "__esModule", {
     value: true
});
exports.default = enabled;

var _defaultConfig = require('../util/default-config');

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function enabled(client, chai, utils, options) {
     var config = (0, _defaultConfig2.default)(options);

     chai.Assertion.addMethod('enabled', function () {
          var negate = utils.flag(this, 'negate');
          var selector = utils.flag(this, 'object');
          var immediately = utils.flag(this, 'immediately');

          if (!immediately) {
               client.waitForEnabled(selector, config.defaultWait, negate);
          }

          var isEnabled = client.isEnabled(selector);
          var enabledArray = Array.isArray(isEnabled) ? isEnabled : [isEnabled];
          var anyEnabled = enabledArray.includes(true);

          this.assert(anyEnabled, 'Expected ' + selector + ' to be enabled but it is not', 'Expected ' + selector + ' to not be enabled but it is');
     });
}