'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = focus;

var _elementExists = require('../util/element-exists');

var _elementExists2 = _interopRequireDefault(_elementExists);

var _defaultConfig = require('../util/default-config');

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function focus(client, chai, utils, options) {
    var config = (0, _defaultConfig2.default)(options);
    chai.Assertion.addMethod('focus', function () {
        var selector = utils.flag(this, 'object');
        var immediately = utils.flag(this, 'immediately');

        if (!immediately) {
            (0, _elementExists2.default)(client, selector, config.defaultWait);
        }

        var hasFocus = client.hasFocus(selector);

        this.assert(hasFocus, 'Expected ' + selector + ' to be focused but it is not', 'Expected ' + selector + ' to not be focused but it is');
    });
}